import json

if __name__ == '__main__':
    print("hello")
    structured = {}
    evidences = []
    f = open('mirai_kitsune_alerts.json', 'r')
    data = f.readlines()
    for line in data:
        # print(line)
        obj = json.loads(line)
        # print(obj["type"])
        key = obj["profileid"] + "_" + obj["twid"]
        if obj["type"] == "alert":
            if key not in structured:
                structured[key] = {}
                structured[key]["threat_level"] = 0
            if obj["threat_level"] > structured[key]["threat_level"]:
                structured[key]["threat_level"] = obj["threat_level"]
        if obj["type"] == "evidence":
            evidences.append(obj)
    for evidence in evidences:
        key = evidence["profileid"] + "_" + evidence["twid"]
        if structured.get(key) is not None:
            if structured[key].get("evidence") is None:
                structured[key]["evidence"] = {}
            module = evidence["detection_module"]
            times = structured[key]["evidence"].get(module)
            if times is None:
                structured[key]["evidence"][module] = 0
            structured[key]["evidence"][module] = structured[key]["evidence"][module] + 1
            if structured[key].get("start_time") is None:
                structured[key]["start_time"] = evidence["timestamp"]
            structured[key]["end_time"] = evidence["timestamp"]
    print(json.dumps(structured))
    output_json = open("mirai_kitsune_alerts_processed.json", 'w')
    json.dump(json.dumps(structured), output_json)
